//Title:        Esercitazione03: applicazione "sample1" 
//Version:      1.0
//Copyright:    Copyright (c) 2006
//Author:       Ilaria Bartolini
//Company:      DEIS - University of Bologna

import java.io.*; // per stampare sul file Censimento73-80.txt 
//import java.util.Date; // per la classe Date

import java.sql.*; 

class Sample1 {
   static {
      try {
         // register the driver with DriverManager
         Class.forName("COM.ibm.db2.jdbc.app.DB2Driver").newInstance();
      } catch (Exception e) {
         e.printStackTrace();
      }
   }

   //  Method:  readEntry
   //  Purpose: to read a string from the user and return it
   //  Input:   The prompt string
   //  Output:  User entry
   public static String readEntry (String prompt)
   {  
    try{      
    StringBuffer buffer = new StringBuffer ();
        System.out.print (prompt);
    System.out.flush ();
        int c = System.in.read ();
        while (c != '\n' && c != -1) {
    buffer.append ((char)c);
    c = System.in.read ();
        }
        return buffer.toString ().trim ();
       }
    catch (IOException e){
      return "";
      }
   }

   public static void main(String argv[]) {
      Connection con = null;

      // URL is jdbc:db2:dbname
      String url = "jdbc:db2:sample";

      try {       
        String userid=readEntry("username: ");
        String passwd=readEntry("password: ");

         // connect with user-provided username and password
         con = DriverManager.getConnection(url, userid, passwd);
           
     int [] anno = new int[8]; 
         
     FileWriter f = null;
     try { f = new FileWriter("Censimento73-80.txt"); }
     catch (IOException e) 
     { System.err.println("Open file error");
      System.exit(1); 
     }
     PrintWriter pw = new PrintWriter(f);
     PreparedStatement pstmt = con.prepareStatement("SELECT firstnme, lastname, hiredate " + 
                      "FROM db2admin.employee " + 
                      "WHERE year(HIREDATE) BETWEEN ? AND ? " + 
                      "ORDER BY hiredate"); 
     int start=1973;
     for (int i=0; i<8; i++)
        anno[i]=start+i;  
     pstmt.setInt(1, anno[0]);
     pstmt.setInt(2, anno[7]);
     ResultSet rs = pstmt.executeQuery();
     pw.println("\n Received results...");
     pw.flush();

     // display the result set  
     while (rs.next()) {
        String fName = rs.getString(1);
        String lName = rs.getString(2);
        Date hiredate = rs.getDate(3);
        //Date currdate = new Date();

        pw.print("NOME= " + fName);
        pw.print("  COGNOME= " + lName);
        pw.println("  DATA DI ASSUNZIONE= " + hiredate);
        pw.flush();
     }
     rs.close();
     pstmt.close();
     pw.close();
     f.close();
     con.close();
      } catch( Exception e ) {
         e.printStackTrace();
      }
   }
}
