//Title:        Esercitazione03: applicazione "progetti"
//Version:      1.0
//Copyright:    Copyright (c) 2006
//Author:       Ilaria Bartolini
//Company:      DEIS - University of Bologna

import java.sql.*;
import java.io.*;

// NOTA: La soluzione proposta presuppone che gli schemi PROGETTI e SPESE 
//	 siano gia' presenti nel DB 

class progetti {
     static {
        try {
            // register the driver with DriverManager
            Class.forName("COM.ibm.db2.jdbc.app.DB2Driver").newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
     }
        
    //Metodo:   fasciaSpesa
    //Finalit: legge il rapporto e restituisce il coefficiente spesa
    static String fasciaSpesa(double rapporto) 
    {
       if(rapporto<=0.25)
            return "A";
       else if(rapporto<=0.50)
            return "B";                
       else if(rapporto<=0.75)
            return "C";                
       else return "D";                                        
    }
    
    public static void main(String argv[]) {
        Connection con = null;

        // URL is jdbc:db2:dbname
        String url = "jdbc:db2:studenti";

        try {
            if (argv.length == 2) {
                String userid = argv[0];
                String passwd = argv[1];

                // connect with user-provided username and password
                con = DriverManager.getConnection(url, userid, passwd);
            }
            else {
                System.out.println("\nUsage: java compito3 [username password]\n");
                System.exit(0);
            }
         
            Statement stmt = con.createStatement();
    
            stmt.executeUpdate("CREATE TABLE CONSUNTIVO (" +
                "COD_PROG CHAR(3) NOT NULL PRIMARY KEY REFERENCES PROGETTI, " +
                "IMP_ASSEGNATO DECIMAL(8,2) NOT NULL CHECK(IMP_ASSEGNATO>0), " + 
                "RESIDUO DECIMAL(8,2) NOT NULL, " +
                "COEFF_SPESA CHAR(1) NOT NULL CHECK(COEFF_SPESA IN ('A','B','C','D')), " +
                "CONSTRAINT C CHECK(RESIDUO BETWEEN 0 AND IMP_ASSEGNATO))" );

            ResultSet rs = stmt.executeQuery("SELECT P.COD_PROG, P.IMP_ASSEGNATO, P.IMP_ASSEGNATO - SUM(S.IMPORTO) AS RESIDUO "+
                "FROM PROGETTI P LEFT OUTER JOIN SPESE S ON (P.COD_PROG = S.COD_PROG) " +
                "GROUP BY P.COD_PROG, P.IMP_ASSEGNATO");
                
            PreparedStatement pstmt = con.prepareStatement("INSERT INTO CONSUNTIVO VALUES (?, ?, ?, ?)");     
            
            while (rs.next()) {
                String cod_pro = rs.getString(1);            
                float imp_ass = rs.getFloat(2);
                float residuo = rs.getFloat(3);
                if (rs.wasNull())
                    residuo = imp_ass;
                double rapporto = residuo/imp_ass;
                String fascia=fasciaSpesa(rapporto);                 
                pstmt.setString(1, cod_pro);
                pstmt.setFloat(2, imp_ass);
                pstmt.setFloat(3, residuo);
                pstmt.setString(4, fascia);                                
                pstmt.executeUpdate();             
            }
            rs.close();
            FileWriter f = null;
            try { f = new FileWriter("consuntivo.txt"); }
            catch (IOException e) 
            { System.err.println("Open file error");
                System.exit(1); 
            }
            PrintWriter pw = new PrintWriter(f);
            // Stampa sul file "consuntivo.txt" il contenuto di CONSUNTIVO
            rs = stmt.executeQuery("SELECT * FROM CONSUNTIVO");
            while (rs.next()) {
                String cod_prog = rs.getString(1);
                float imp_ass = rs.getFloat(2);
                float residuo = rs.getFloat(3);
                String fascia = rs.getString(4);
                pw.print("Codice progetto= " + cod_prog);
                pw.print(" Importo assegnato= " + imp_ass);
                pw.print(" Residuo= " + residuo);
                pw.println(" Fascia Spesa= " + fascia);
                pw.flush();
            }
            rs.close();
            f.close();
            pw.close();
            stmt.close();
            pstmt.close();
            con.close();
        } catch(Exception e) {
            e.printStackTrace();
        }
    }
}
